package com.ruoyi.web.system;

import java.util.List;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletResponse;

import com.ruoyi.common.annotation.Anonymous;
import org.apache.commons.lang3.ArrayUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.Role;
import com.ruoyi.common.core.domain.entity.User;
import com.ruoyi.common.core.domain.vo.UserVO;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.validate.ValidGroup;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.enums.LogBizType;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.system.dept.domain.DeptQuery;
import com.ruoyi.system.dept.service.DeptService;
import com.ruoyi.system.post.service.PostService;
import com.ruoyi.system.role.service.RoleService;
import com.ruoyi.system.user.domain.UserQuery;
import com.ruoyi.system.user.service.UserAssembler;
import com.ruoyi.system.user.service.UserConverter;
import com.ruoyi.system.user.service.UserService;
import com.ruoyi.system.user.utils.UserUtil;

/**
 * 用户信息
 *
 * @author ruoyi
 */
@RestController
@RequestMapping("/system/user")
public class SysUserController extends BaseController
{
    @Autowired
    private UserService userService;

    @Autowired
    private RoleService roleService;

    @Autowired
    private DeptService deptService;

    @Autowired
    private PostService postService;

    @Autowired
    private UserAssembler userAssembler;

    @Autowired
    private UserConverter userConverter;

    /**
     * 获取用户列表
     */
    @PreAuthorize("@ss.hasPermi('system:user:list')")
    @GetMapping("/list")
    public TableDataInfo list(UserQuery query)
    {
        startPage();
        query.setScope(true);
        List<UserVO> list = userService.selectUserListScope(query);
        return getDataTable(list);
    }

    /**
     * 获取所有用户名称列表
     * @return
     */
    @PreAuthorize("@ss.hasPermi('system:user:list')")
    @GetMapping("/listAll")
    public AjaxResult listAll() {
        return success(userService.selectAllUserNameList());
    }

    /**
     * 获取用户列表ByIds
     */
    @PreAuthorize("@ss.hasPermi('system:user:list')")
    @PostMapping("/listByIds")
    public AjaxResult list(@RequestBody List<Long> userIds)
    {
        List<UserVO> list = userService.selectByIds(userIds);
        return success(list);
    }

    @Log(title = "用户管理", businessType = BusinessType.EXPORT)
    @PreAuthorize("@ss.hasPermi('system:user:export')")
    @PostMapping("/export")
    public void export(HttpServletResponse response, UserQuery query)
    {
        query.setScope(true);
        query.setExcludeUserId(1L);
        List<UserVO> list = userService.selectUserListScope(query);
        ExcelUtil<UserVO> util = new ExcelUtil<UserVO>(UserVO.class);
        util.exportExcel(response, list, "用户数据");
    }

    @PostMapping("/importTemplate")
    public void importTemplate(HttpServletResponse response)
    {
        ExcelUtil<User> util = new ExcelUtil<User>(User.class);
        util.importTemplateExcel(response, "用户数据");
    }

    /**
     * 根据用户编号获取详细信息
     */
    @PreAuthorize("@ss.hasPermi('system:user:query')")
    @GetMapping(value = { "/", "/{userId}" })
    public AjaxResult getInfo(@PathVariable(value = "userId", required = false) Long userId)
    {
        userService.checkUserDataScope(userId);
        AjaxResult ajax = AjaxResult.success();
        List<Role> roles = roleService.selectRoleAll();
        ajax.put("roles", User.isAdmin(userId) ? roles : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
        ajax.put("posts", postService.selectPostAll());
        if (StringUtils.isNotNull(userId))
        {
            UserVO user = userService.selectUserById(userId);
            ajax.put(AjaxResult.DATA_TAG, user);
            ajax.put("postIds", postService.selectPostListByUserId(userId));
            ajax.put("roleIds", user.getRoles().stream().map(Role::getRoleId).collect(Collectors.toList()));
        }
        return ajax;
    }

    /**
     * 新增用户
     */
    @PreAuthorize("@ss.hasPermi('system:user:add')")
    @Log(title = "新增用户", businessType = BusinessType.INSERT, bizIdName = "arg0", bizType = LogBizType.USER)
    @PostMapping
    public AjaxResult add(@Validated(ValidGroup.Create.class) @RequestBody UserVO user) {
        user = userConverter.toVOByCreate(user);
        user.setCreateBy(getUsername());
        deptService.checkDeptDataScope(user.getDeptId());
        roleService.checkRoleDataScope(user.getRoleIds());
        return toAjax(userService.insertUser(user));
    }

    /**
     * 修改用户
     */
    @PreAuthorize("@ss.hasPermi('system:user:edit')")
    @Log(title = "修改用户", businessType = BusinessType.UPDATE, bizIdName = "arg0", bizType = LogBizType.USER)
    @PutMapping
    public AjaxResult edit(@Validated(ValidGroup.Update.class) @RequestBody UserVO user) {
        user = userConverter.toVOByUpdate(user);
        user.setUpdateBy(getUsername());
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        deptService.checkDeptDataScope(user.getDeptId());
        if (user.getRoleIds() != null) {
            roleService.checkRoleDataScope(user.getRoleIds());
        }
        return toAjax(userService.updateUser(user));
    }

    /**
     * 删除用户
     */
    @PreAuthorize("@ss.hasPermi('system:user:remove')")
    @Log(title = "删除用户", businessType = BusinessType.DELETE, bizIdName = "arg0", bizType = LogBizType.USER)
    @DeleteMapping("/{userIds}")
    public AjaxResult remove(@PathVariable Long[] userIds)
    {
        if (ArrayUtils.contains(userIds, getUserId()))
        {
            return error("当前用户不能删除");
        }
        return toAjax(userService.deleteUserByIds(userIds));
    }

    /**
     * 重置密码
     */
    @PreAuthorize("@ss.hasPermi('system:user:resetPwd')")
    @Log(title = "重置用户密码", businessType = BusinessType.UPDATE, bizIdName = "arg0", bizType = LogBizType.USER)
    @PutMapping("/resetPwd")
    public AjaxResult resetPwd(Long userId)
    {
        UserVO user = userService.selectUserById(userId);
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());

        String password = UserUtil.randomPassword();
        User data = new User();
        data.setUserId(userId);
        data.setPassword(SecurityUtils.encryptPassword(password));
        data.setUpdateBy(getNickName());
        int rows = userService.resetPwd(data);
        if (rows > 0) {
            JSONObject json = new JSONObject();
            json.put("password", password);
            json.put("userName", user.getUserName());
            return AjaxResult.success("重置密码成功", json);
        }
        return error("重置密码失败");
    }

    /**
     * 状态修改
     */
    @PreAuthorize("@ss.hasPermi('system:user:edit')")
    @Log(title = "修改用户状态", businessType = BusinessType.UPDATE, bizIdName = "arg0", bizType = LogBizType.USER)
    @PutMapping("/changeStatus")
    public AjaxResult changeStatus(@RequestBody User user)
    {
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        user.setUpdateBy(getUsername());
        return toAjax(userService.updateUserStatus(user));
    }

    /**
     * 根据用户编号获取授权角色
     */
    @PreAuthorize("@ss.hasPermi('system:user:query')")
    @GetMapping("/authRole/{userId}")
    @Log(title = "获取用户授权角色", businessType = BusinessType.OTHER, bizIdName = "arg0", bizType = LogBizType.USER)
    public AjaxResult authRole(@PathVariable("userId") Long userId)
    {
        AjaxResult ajax = AjaxResult.success();
        User user = userService.selectUserById(userId);
        List<Role> roles = roleService.selectRolesByUserId(userId);
        ajax.put("user", user);
        ajax.put("roles", User.isAdmin(userId) ? roles : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
        return ajax;
    }

    /**
     * 用户授权角色
     */
    @PreAuthorize("@ss.hasPermi('system:user:edit')")
    @Log(title = "用户授权角色", businessType = BusinessType.GRANT, bizIdName = "arg0", bizType = LogBizType.USER)
    @PutMapping("/authRole")
    public AjaxResult insertAuthRole(Long userId, Long[] roleIds)
    {
        userService.checkUserDataScope(userId);
        roleService.checkRoleDataScope(roleIds);
        userService.insertUserAuth(userId, roleIds);
        return success();
    }

    /**
     * 获取部门树列表
     */
    @PreAuthorize("@ss.hasPermi('system:user:list')")
    @GetMapping("/deptTree")
    public AjaxResult deptTree(DeptQuery dept)
    {
        return success(deptService.selectDeptTreeList(dept));
    }

    /**
     * 已读导览
     */
    @PutMapping("/guide")
    @Anonymous
    public AjaxResult guide(String key)
    {
        return success(userService.readGuide(getUserId(), key));
    }


}
